/*

f-cpu/qdcpoc/control.c
created Wed Jul 11 02:18:29 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG 2001 all rights reserved. you're warned !!!
read f-cpu/qdcpoc/about.txt for the details.

This file is included in f-cpu/qdcpoc/main.c

*/


void fc0_cycle_writeback() {
  u64 t1,t4;
  SMAX t2, t3;
  int i,j,k,l,m;

  /* check if there is something to write : */
  if (R7write_address0 > 0) {
#ifndef QUICKnLAXIST
    if (R7write_address1 == R7write_address0) {
      fprintf(stderr,"\nPanic !! trying to write the same register 2x at the same time !!!\n");
      exit(6);
    }
#endif
    /* update the register : */
    reg_set[R7write_address0] =
       (reg_set[R7write_address0] & ~R7write_mask0)
                 | (R7write_port0 &  R7write_mask0);
    /* in HW, this is done simply with a "write enable" pin in the FF gate */

    /* Update the flags (in parallel). The "trick" is that there is a local copy which
       is updated when the corresponding write mask/enable is set. */
    t1 = 1LL << R7write_address0; /* create the mask, it's purely a C stuff. */

    /* update LSB */
    if ((R7write_mask0 & 1)==1) {
      t2 = ~((R7write_port0 & 1)-1); /* for the LSB, 0 or -1L with nasty trick to propagate the LSB */
      LSBflag = (LSBflag & ~t1) | (t2 & t1);
    }

    /* update the MSB */
    if ((R7write_mask0 >>63)!=0) {
      t3 = (SMAX)R7write_port0 >> 63;      /* for the MSB, 0 or -1L through sign propagation */
      MSBflag = (MSBflag & ~t1) | (t3 & t1);
    }

    /* update the null bits.
       some background : the register set can be updated in selected parts. The 0 flag
       reflects the status of ALL the bits in every register, but the write ports
       provide partial values. We have to keep the rest of the partial values
       "cached" (because we don't want to read the register) and we update a fraction
       of the bits. What the decoder sees is the OR of all partial 8-inputs ORs (negated).
    */
    i = null_flags[R7write_address0];
    k = 0; /* shift counter */
    l = 1; /* mask for i */
    for (j=0; j<8; j++) {   /* on peut probablement virer la variable j */
      if (((R7write_mask0 >> k) & 255) !=0) {   /* check if the partial OR must be modified */
	m=0;
	if (((R7write_port0 >> k) & 255) !=0) /* this is one 8-bit partial OR */
	  m = -1;
	i = (i & ~l) | (m & l);
      }
      k += 8;
      l <<= 1;
    }
    null_flags[R7write_address0] = i;
    /* 8-input OR of the partial results : */
    t4 = 0;
    if (i == 0)
      t4 = -1LL;
    NULLflag = (NULLflag & ~t1) | (t4 & t1);

    /* This code is ugly but it shows that we can keep the flags up to date
       without even reading the register set. */

  }

  /* same as above, but without checking the collision (debug only) and the comments are removed. */
  if (R7write_address1 > 0) {
    reg_set[R7write_address1] =
      (reg_set[R7write_address1] & ~R7write_mask1)
                | (R7write_port1 &  R7write_mask1);

    t1 = 1LL << R7write_address1;
    if ((R7write_mask1 & 1)==1) {
      t2 = ~((R7write_port1 & 1)-1);
      LSBflag = (LSBflag & ~t1) | (t2 & t1);
    }

    if ((R7write_mask1 & (1LL<<63))==1) {
      t3 = (SMAX)R7write_port1 >> 63;
      MSBflag = (MSBflag & ~t1) | (t3 & t1);
    }

    i = null_flags[R7write_address1];
    k = 0; /* shift counter */
    l = 1; /* mask for i */
    for (j=0; j<8; j++) {
      if (((R7write_mask1 >> k) & 255) !=0) {   /* check if the partial OR must be modified */
	m=0;
	if (((R7write_port1 >> k) & 255) !=0) /* this is one 8-bit partial OR */
	  m = -1;
	i = (i & ~l) | (m & l);
      }
      k += 8;
      l <<= 1;
    }
    null_flags[R7write_address1] = i;
    /* 8-input OR of the partial results : */
    t4 = 0;
    if (i == 0)
      t4 = -1LL;
    NULLflag = (NULLflag & ~t1) | (t4 & t1);
  }
}

/* this part is mainly a big mux (6->2) (5->2 ?) */
void fc0_cycle_Xbar_write() {

  /* this is still doubtful whether this is right : */
  R7write_address0 = sched_FIFO[1].write0;
  R7write_address1 = sched_FIFO[1].write1;
  R7write_mask0 = mask_LUT[sched_FIFO[1].mask0];
  R7write_mask1 = mask_LUT[sched_FIFO[1].mask1];
  /* remark : we can predecode the register number
     long before it is being written. that, and other
     things such as the write mask. */

  Xbar_write_address0 = sched_FIFO[1].unit0;
  Xbar_write_address1 = sched_FIFO[1].unit1;

  if (Xbar_write_address0 > 0) {
    switch(Xbar_write_address0) {
      case 1: R7write_port0 = Xbar_read_port1; break; /* register to register move */
      case 2: R7write_port0 = DEC_CIP; break;
      case 3: R7write_port0 = DEC_NIP; break;  /* jmpa + "link", or loopentry */
      case 4: R7write_port0 = Xbar_ROP2_port; break;
      case 5: R7write_port0 = Xbar_ASU_port0; break;
      case 6: R7write_port0 = Xbar_ASU_port1; break;  /* this one could be removed */
      default : fprintf(stderr,"Error in Case"); exit(7);
    }
  }

    /* cut, paste and rename : */
  if (Xbar_write_address1 > 0) {
    switch(Xbar_write_address1) {
      case 1: R7write_port1 = Xbar_read_port1; break;
      case 2: R7write_port1 = DEC_CIP; break;
      case 3: R7write_port1 = DEC_NIP; break;
      case 4: R7write_port1 = Xbar_ROP2_port; break;
      case 5: R7write_port1 = Xbar_ASU_port0; break; /* this one could be removed */
      case 6: R7write_port1 = Xbar_ASU_port1; break;
      default : fprintf(stderr,"Error in Case"); exit(8);
    }
  }
}

void fc0_cycle_Xbar_read() {
  int i;

  /* 1) bufferize the ROP2 signals : */
  i=ROP2_function_LUT[ROP2_function]; /* table lookup : 3 bits->4 bits */
  ROP2_function_bit0 = ~((i & 1) -1);   /* bit propagation */
  ROP2_function_bit1 = ~(((i >> 1) & 1) -1);
  ROP2_function_bit2 = ~(((i >> 2) & 1) -1);
  ROP2_function_bit3 = ~(((i >> 3) & 1) -1);
  Xbar_EU_ROP2 = EU_ROP2;
  Xbar_ROP2_mode = ROP2_mode;

  /* Xbar : big multiplex */

  if (Xbar_read_address0 > 0) {
    switch(Xbar_read_address0) {
      case 1: Xbar_read_port0 = R7read_port0; break;  /* normal read */
      case 2: Xbar_read_port0 = DEC_imm_port; break;  /* read an immediate data */
      case 3: Xbar_read_port0 = R7write_port0; break; /* bypass through R7 write port 0 */
      case 4: Xbar_read_port0 = R7write_port1; break; /* bypass through R7 write port 1 */
      default : fprintf(stderr,"Error in Case"); exit(9);
    }
  }

    /* cut, paste and rename : */
  if (Xbar_read_address1 > 0) {
    switch(Xbar_read_address1) {
      case 1: Xbar_read_port1 = R7read_port1; break;  /* normal read */
      case 2: Xbar_read_port1 = DEC_NIP; break;  /* used by LOOPENTRY & LOADADDRI, check coherency with the manual !!! */
      case 3: Xbar_read_port1 = R7write_port0; break; /* bypass through R7 write port 0 */
      case 4: Xbar_read_port1 = R7write_port1; break; /* bypass through R7 write port 1 */
      default : fprintf(stderr,"Error in Case"); exit(10);
    }
  }
  if (Xbar_read_address2 > 0) {
    switch(Xbar_read_address2) {
      case 1: Xbar_read_port2 = R7read_port2; break;  /* normal read */
	/**/
      case 3: Xbar_read_port2 = R7write_port0; break; /* bypass through R7 write port 0 */
      case 4: Xbar_read_port2 = R7write_port1; break; /* bypass through R7 write port 1 */
      default : fprintf(stderr,"Error in Case"); exit(11);
    }
  }

}

void fc0_cycle_decode() {
  int i;

 /* extract the register fields from the instructions */
  R7read_address0 = (instruction_buffer >> 14 ) & 63;
  R7read_address1 = (instruction_buffer >> 20 ) & 63;
  R7read_address2 = (instruction_buffer >> 26 ) & 63;
  RW2 = R7read_address2 ^ 1;  /* this field is used as destination in 3R1W or second dest in 2R2W */

  /* other fields */
  current_opcode = instruction_buffer & 0xFF;
  ROP2_function = (instruction_buffer >> 5) & 7;
  imm16 = (instruction_buffer >> 10) & 0xFFFF ;
  imm8 = (instruction_buffer >> 12) & 0xFF ;

  /* register read */
  R7read_port0 = reg_set[R7read_address0];
  R7read_port1 = reg_set[R7read_address1];
  R7read_port2 = reg_set[R7read_address2];

  current_opcode = instruction_buffer & 0xFF; /* is the mask necessary ? */
  DEC_CIP = FETCH_CIP << 2;
  DEC_CIP = FETCH_NIP << 2;

  /* decode the conditions : */
  switch((instruction_buffer >> 11) & 3) {
    case 0: condition = NULLflag;
    case 1: condition = MSBflag;
    case 2: condition = LSBflag;
    default: condition = 0; /* ??? */
  }
  condition = ((~condition >> R7read_address1)
             ^ (instruction_buffer >> 10)) & 1; /* negation of the condition */


/* check register availability :
   the FIFO shift is merged with the comparison in this loop.
   however, sched_FIFO[0] is considered as "ready" so
   we don't check it and the first stage is out of the loop.
 */
  sched_FIFO[0].write0 = sched_FIFO[1].write0;
  sched_FIFO[0].mask0  = sched_FIFO[1].mask0;
  sched_FIFO[0].write1 = sched_FIFO[1].write1;
  sched_FIFO[0].mask1  = sched_FIFO[1].mask1;

/*sched_FIFO[0].unit0  = sched_FIFO[1].unit0;   useless.
  sched_FIFO[0].unit1  = sched_FIFO[1].unit1; */

  register0_ready = 1;
  register1_ready = 1;
  register2_ready = 1;
  RW2_ready = 1;

  for (i=1; i<(DEPTH_FIFO-1); i++) {
    /* comparison */
    if ((sched_FIFO[i].write0 == R7read_address0)
      ||(sched_FIFO[i].write1 == R7read_address0))
      register0_ready = 0;
    if ((sched_FIFO[i].write0 == R7read_address1)
      ||(sched_FIFO[i].write1 == R7read_address1))
      register1_ready = 0;
    if ((sched_FIFO[i].write0 == R7read_address2)
      ||(sched_FIFO[i].write1 == R7read_address2))
      register2_ready = 0;
    if ((sched_FIFO[i].write0 == RW2)
      ||(sched_FIFO[i].write1 == RW2))
      RW2_ready = 0;

/* nb : we are forced to check the availability of the
  destination register because we handle multiple sizes
  and a partial write could cause wonderful worries if
  it was performed at the wrong time.  */

    /* FIFO shift */
    sched_FIFO[i].write0 = sched_FIFO[i+1].write0;
    sched_FIFO[i].unit0  = sched_FIFO[i+1].unit0;
    sched_FIFO[i].mask0  = sched_FIFO[i+1].mask0;
    sched_FIFO[i].write1 = sched_FIFO[i+1].write1;
    sched_FIFO[i].unit1  = sched_FIFO[i+1].unit1;
    sched_FIFO[i].mask0  = sched_FIFO[i+1].mask0;
  }

/* the following is useless : sched_FIFO[DEPTH_FIFO]
 is hardwired to 0, it is never written to.
  sched_FIFO[DEPTH_FIFO].write0 = 0;
  sched_FIFO[DEPTH_FIFO].unit0  = 0;
  sched_FIFO[DEPTH_FIFO].write1 = 0;
  sched_FIFO[DEPTH_FIFO].unit1  = 0;
*/
}


void fc0_cycle_fetcher() {
  if (get_next_instruction) {
    if (FETCH_CIP >= fetcher_buffer_size) {
      printf("\nEnd of program reached (pipeline flush not yet implemented)\n");
      exit(12);
    }
    get_next_instruction = 0;
    instruction_buffer = fetcher_buffer[FETCH_CIP];
    FETCH_CIP = FETCH_NIP;
    FETCH_NIP++;
  }
}

