/*

f-cpu/qdcpoc/main.c
created Wed Jul 11 01:23:48 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG all rights reserved. you're warned !!!
read f-cpu/qdcpoc/about.txt for the details.

*/

#include "qdcpoc.h"

void lli(UMAX i) {
  printf("%016llX\n",i);
}

#include "control.c"
#include "execution.c"

void init_fc0() {
  /* R7 */
  memset(reg_set,0,sizeof(reg_set));
  R7write_mask0 = 0;
  R7write_mask1 = 0;
  R7write_port0 = 0;
  R7write_port1 = 0;
  R7write_address0 = 0;
  R7write_address1 = 0;
  R7read_port0 = 0;
  R7read_port1 = 0;
  R7read_port2 = 0;
  R7read_address0 = 0;
  R7read_address1 = 0;
  R7read_address2 = 0;
  memset(null_flags,0,sizeof(null_flags));
  NULLflag = 0xFFFFFFFFFFFFFFFFLL;  /* the flag is set if the register is zero */
  LSBflag = 0;
  MSBflag = 0;

  /* Xbar */
  Xbar_write_address0 = 0;
  Xbar_write_address1 = 0;
  Xbar_read_address0 = 0;
  Xbar_read_address1 = 0;
  Xbar_read_address2 = 0;
  Xbar_ROP2_port = 0;
  Xbar_ASU_port0 = 0;
  Xbar_ASU_port1 = 0;
  Xbar_read_port0 = 0;
  Xbar_read_port1 = 0;
  Xbar_read_port2 = 0;

  EU_ROP2 = 0;
  ROP2_function_bit0 = 0;
  ROP2_function_bit1 = 0;
  ROP2_function_bit2 = 0;
  ROP2_function_bit3 = 0;
  ROP2_function = 0;
  ROP2_mode = 0;

  FETCH_NIP = 0;
  FETCH_NIP = 0;
  DEC_imm_port = 0;
  DEC_CIP = 0;
  DEC_NIP = 0;
  current_opcode = 0;
  instruction_buffer = 0;
  get_next_instruction = 1; /* start the pipeline */

/* scoreboard = 0; */
  memset(sched_FIFO,0,sizeof(sched_FIFO));
  register0_ready = 0;
  register1_ready = 0;
  register2_ready = 0;
  pointer_ready = 0; /* unused */
  condition_true = 0;
  RW2_ready = 0;
  RW2 = 0;

}

/* initialize the fetcher buffer, its configuration and its contents. */
void init_fetcher(char *fname) {
  FILE *file_in;
  int res;
  struct stat buf;

  res = stat(fname,&buf);
  if (res != 0) {
    fprintf(stdout,"Error : can't access %s !\n\7",fname);
    exit(1);
  }

  fetcher_buffer_size = buf.st_size;
  if ((fetcher_buffer_size & 3)!=0) {
    fprintf(stdout,"Error : %s's size is not 0 mod 4\n\7",fname);
    exit(2);
  }

  if (fetcher_buffer != NULL)
    free(fetcher_buffer);

  fetcher_buffer = malloc(fetcher_buffer_size);
  if (fetcher_buffer == NULL) {
    fprintf(stdout,"Error : can't allocate memory for %li bytes\n\7", fetcher_buffer_size);
    exit(3);
  }

  file_in = fopen(fname,"rb");
  if (fname == NULL) {
    fprintf(stdout,"Error : can't fopen %s\n\7", fname);
    exit(4);
  }

  fread (fetcher_buffer,fetcher_buffer_size,1,file_in);
  fetcher_buffer_size >>= 2;

  DEC_CIP = 0;
  DEC_NIP = 0;    /*  ??????  */
  FETCH_CIP = 0;
  FETCH_NIP = 1;
}

void fc0_cycle() {
  /* read the doxxx to understand the order in which the
     functions are called (hint : counter-pipeline order
     that reduces the overhead caused by the duplication
     of the variables...) */

  /* control.c */
  fc0_cycle_writeback();
  fc0_cycle_Xbar_write();

  /* execution.c */
  fc0_cycle_ASU2();
  fc0_cycle_ROP2();
  fc0_cycle_ASU1();

  /* control.c */
  fc0_cycle_Xbar_read();
  fc0_cycle_decode();
  fc0_cycle_fetcher();

  /* others to come */

}


int main(int argc, char **argv) {

  if (argc <= 1) {
    printf("need 1 arg : please give the input filename !\n");
    exit(5);
  }

  init_fc0();
  init_fetcher(argv[1]);

  do {
    fc0_cycle();
    get_next_instruction = 1;
  } while (1);

  return 0;
}
