/*
f-cpu/ygasm/ygasm_bin.c
created Sun Jul 15 19:35:30 by Yann Guidon <whygee@f-cpu.org>

this part controls the generation of the binary output stream.
I have forgotten where the GRAZER is, it alread contained some nice
stuff, but i'm rewriting it anyway.

*/

#define BIN_BUFF_SIZE 1024

u8 imm8, opcode, reg_src1, reg_src2, reg_dest, SIMD_flag;
u16 imm16;
u32 current_instruction;
unsigned int current_pos, current_PC;
u8 bin_buffer[BIN_BUFF_SIZE];


void init_out_buff() {
  imm8 = 0;
  opcode =0;
  reg_src1 = 0;
  reg_src2 = 0;
  reg_dest = 0;
  imm16 = 0;
  current_instruction = 0;
  current_pos= 0;
  SIMD_flag = 0;
}

void emit_byte(u8 b) {
  bin_buffer[current_pos++] = b;
  if (current_pos >= BIN_BUFF_SIZE) {
    /* flush the buffer */
    fwrite(bin_buffer,1,BIN_BUFF_SIZE,out_file);
    current_pos = 0;
  }
  current_PC ++;  
}

void emit_instruction() {
  if (current_PC & 3) {
    ygasm_error("yuk ! the instruction is not aligned on a 4-byte boundary",NULL);
  }

  current_instruction |= opcode
    | (reg_dest << 26)
    | (reg_src2 << 20)
    | (reg_src1 << 14)
    | (SIMD_flag << 10)
    | (imm8 << 12)
    | (imm16 << 10);

  /*  bin_buffer[current_pos++] = current_instruction;
      BAAAAD !!! this is an endian-dependent code !!!  */

  /* that's somewhat better, even though it's almost an overkill :-D */
  emit_byte(current_instruction & 0xFF);
  emit_byte((current_instruction >> 8) & 0xFF);
  emit_byte((current_instruction >> 16) & 0xFF);
  emit_byte((current_instruction >> 24) & 0xFF);

  /* reset for the next round : */

  SIMD_flag = 0;
  imm8 = 0;
  opcode = 0;
  reg_src1 = 0;
  reg_src2 = 0;
  reg_dest = 0;
  imm16 = 0;
}


void flush_out_buff() {
  fwrite(bin_buffer,1,current_pos,out_file);
  fclose(out_file);
}

void align_pc(u64 a) {
  u64 b;
  unsigned int i;

  if ((a < 2) || (a >100000)) {  /* reality check, or if the boundary is negative */
    ygasm_error("wrong alignment boundary range",NULL);
  }
  if ((a & -a)!= a) { /* check if the parameter is a power of two */
    ygasm_error("alignment to a boundary not power of two",NULL);
  }

  b = a-1; /* make the mask, ie : a= 0x10 => b= 0xF */
  i = (current_PC + b) & b; /* how many instructions to pad ? */

  while (i!=0) {
    i-- ;
    emit_byte (0);
  }

}
