/*

f-cpu/ygasm/ygasm_files.c
taken away from (and included by) f-cpu/ygasm/ygasm.c
Sun Jul 15 19:15:21 by Yann GUIDON <whygee@f-cpu.org>
This part mainly deals with the FLEX interface with the
files, in the frame of the #defines.

 */

/* this re-defines the input method for FLEX */
#define YY_INPUT(buf,result,max_size)  buf[0]=get_new_char(&result);

int scan_from_define=0; /* from a file at the beginning */

/* no buffered reads because FLEX does some weird stuffs */
/* we're not running for blazing speed anyway... */
char get_new_char(int *size) {
  int character;

  if (scan_from_define) {
/* get from a DEFINE buffer */
     character=current_define->buffer[current_define->char_counter++];
     if (current_define->char_counter > current_define->buffer_size) {
/* pops the define */
       current_define->char_counter = -1;
       if (current_define->last_scan)
         current_define=current_define->last_scan; /* pop */
       else
         scan_from_define=0; /* nothing to pop */
     }
  }
  else {

/* get from a FILE */

get_again:
    character=fgetc(include_prec->input_file);

/* End of file ? */
    if (character==EOF) {
      if (fclose(include_prec->input_file))
        ygasm_error("can't close the file",NULL);
      if (include_prec->next == include_prec) {
        *size=0;
        return (0); /* we have reached the end of the main file */
      }
/* pops a file from the stack */
      include_prec=include_prec->next;
      Line_Number = include_prec->node_line_number ;
      goto get_again; /* so EOF is tested... */
    }
   /* counts the lines */
    if (character=='\n')
      Line_Number ++;
  }
  *size=1;
  return (character);
}
